;*=====================================================================*/
;*    .../prgm/project/bigloo/work/bignux/src/Llib/gtkserver.scm       */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Tue Sep 19 16:54:33 2006                          */
;*    Last change :  Tue Sep 19 20:11:16 2006 (serrano)                */
;*    Copyright   :  2006 Manuel Serrano                               */
;*    -------------------------------------------------------------    */
;*    The binding with the GTKSERVER library                           */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    The module                                                       */
;*---------------------------------------------------------------------*/
(module gtkserver_gtk
   (extern ($gtk::string (::string) "gtk"))
   ;(extern (macro gtk::string (::string) "gtk"))
   (export (gtk-init::bstring)
	   (gtk-window-new::bstring ::int)
	   (gtk-table-new::bstring ::int ::int ::int)
	   (gtk-button-new-with-label::bstring ::bstring)
	   (gtk-label-new::bstring ::bstring)
	   ;; here you should complete the following prototypes
	   
	   (gtk-table-attach-defaults::bstring ::bstring ::bstring ::int ::int ::int ::int)
	   (gtk-container-add::bstring ::bstring ::bstring)
	   (gtk-window-set-title::bstring ::bstring ::bstring)
           (gtk-image-new::bstring)
           (gtk-widget-show-all::bstring ::bstring)
           
           (gtk-widget-show::bstring ::bstring)
	   (gtk-server-callback::bstring)
	   (gtk-server-update::bstring)
	   (gtk-frame-new::bstring)
           (gtk-entry-new::bstring)
	   
	   (gtk-box-pack-start::bstring ::bstring ::bstring 
	                   ::bool ::bool ::int)
	   (gtk-box-pack-end::bstring ::bstring  ::bstring 
	                     ::bool ::bool ::int)
	   (gtk-vbox-new::bstring ::bool ::int)
	   (gtk-hbox-new::bstring ::bool ::int)
	   (gtk-hseparator-new::bstring)
	   (gtk-scrolled-window-new::bstring)
	   (gtk-text-buffer-new::bstring)

           (gtk-text-view-new-with-buffer::bstring ::bstring)
           (gtk-text-view-set-editable::bstring ::bstring ::bool) 
           (gtk-text-view-set-wrap-mode::bstring ::bstring ::int)
           (gtk-text-set-word-wrap::bstring ::bstring ::int)
           (gtk-server-enable-c-string-escaping::bstring)
           (gtk-server-disable-c-string-escaping::bstring)
           (gtk-entry-get-text::bstring ::bstring)
           (gtk-text-buffer-set-text::bstring ::bstring ::bstring ::int)
           (gtk-text-buffer-delete::bstring ::bstring ::bstring ::bstring)
           (gtk-text-buffer-get-bounds::bstring ::bstring ::bstring ::bstring)
           
           (gtk-text-buffer-get-end-iter::bstring ::bstring ::bstring)
	   (gtk-text-buffer-get-text::bstring ::bstring
	              ::bstring
	              ::bstring
	              ::bool)
	   (gtk-text-buffer-get::bstring
	              ::bstring
	              ::bstring
	              ::bstring
	              ::bool)
	   (gtk-text-buffer-insert::bstring
	             ::bstring
	             ::bstring
	             ::bstring
                     ::int)
          
	   gtk-image-set-from-pixmap
	   gdk-gc-new
	   gdk-pixmap-new
	   gtk-widget-get-parent-window
	   g-object-unref
	   gdk-color-parse
	   gdk-gc-set-rgb-bg-color
	   gdk-gc-set-rgb-fg-color
	   gdk-draw-layout
	   gtk-widget-create-pango-layout
	   gdk-draw-rectangle
	   gdk-draw-line
	   gtk-event-box-new
	   gtk-image-new-from-file
	   gtk-window-set-position
	   gtk-window-set-default-size
	   gtk-window-set-resizable
	   gtk-text-buffer-remove-tag-by-name
	   gtk-text-buffer-apply-tag-by-name
	   gtk-text-buffer-create-tag
	   gtk-font-selection-new
	   gtk-font-selection-get-font-name
	   gtk-font-selection-dialog-new
	   gtk-window-set-transient-for
	   gtk-message-dialog-new
	   gtk-dialog-run
	   gdk-font-load
	   gtk-widget-hide
	   gtk-server-connect
	   gtk-get-mouse-button
	   gtk-mouse-x
	   gtk-mouse-y
	   gtk-image-set-from-file
	   gtk-server-timeout
	   gtk-text-iter-forward-search
	   gtk-text-buffer-select-range
	   gtk-text-buffer-get-start-iter
	   gtk-text-iter-forward-visible-cursor-position
	   gtk-text-buffer-create-mark
	   gtk-text-buffer-get-iter-at-mark
	   gtk-text-buffer-delete-mark
	   gtk-text-buffer-delete-mark-by-name
	   gtk-text-buffer-get-selection-bounds
	   gtk-entry-set-text
	   gtk-file-chooser-get-filename
	   gtk-file-chooser-widget-new
	   gtk-file-filter-new
	   gtk-file-filter-add-pattern
	   gtk-file-filter-set-name
	   gtk-file-chooser-add-filter
	   gtk-file-chooser-set-filename
	   (gtk-load-lines fname)
	   (gtk-text-buffer-get-list txt startit endit)
	   (gtk-save-buffer txt file-name startit endit)
	   (gtk-ins-lines xs buffer nd)
           
	   gtk-menu-bar-new
	   gtk-menu-new
	   gtk-menu-item-new
	   gtk-menu-item-new-with-label
	   gtk-menu-shell-append
	   gtk-menu-item-new-with-mnemonic
	   gtk-menu-item-set-submenu
           expression->string
           string->expression
           expression->pretty    
	   (pack-homogeneously hbx . components)
	   (pack-pack vbx . components)))

(define-inline (gtk::bstring cmd::bstring)
   (cond-expand
      (bigloo-c
       ($gtk cmd))
      (else
       (with-input-from-port (current-input-port)
	  (lambda ()
	     (display cmd (current-output-port))
	     (flush-output-port (current-output-port))
	     (read-string (current-input-port)))))))

(define (gtk-init::bstring)
   (gtk "gtk_init NULL NULL"))
      
(define (gtk-window-new::bstring arg0::int)
        (gtk (string-append "gtk_window_new" " " 
           (number->string arg0))) 
     )


(define (gtk-table-new::bstring arg0::int arg1::int arg2::int)
     (gtk (string-append "gtk_table_new"
              " " (number->string arg0)
              " " (number->string arg1)
              " " (number->string arg2))))
              

(define (gtk-button-new-with-label::bstring rot::bstring)
       (gtk (string-append "gtk_button_new_with_label"
                  " "  "\"" rot "\"")))
                  
(define (gtk-label-new::bstring text::bstring)
      (gtk (string-append "gtk_label_new"
                  " "  "\"" text "\"")))

(define (gtk-table-attach-defaults::bstring tab::bstring c::bstring x1::int y1::int x2::int y2::int)
       (gtk (string-append "gtk_table_attach_defaults " 
                    tab 
                            " " c " " 
                      (number->string x1) " "
                      (number->string y1) " "
                      (number->string x2) " "
                      (number->string y2) )))

(define (gtk-container-add::bstring w::bstring c::bstring)
       (gtk (string-append "gtk_container_add " w " " c)))
       
(define (gtk-window-set-title::bstring w::bstring t::bstring)
        (gtk (string-append "gtk_window_set_title " w 
                          "  \"" t  "\"")))
                          
(define (gtk-widget-show-all::bstring w::bstring)
         (gtk  (string-append "gtk_widget_show_all " w)))

(define (gtk-widget-show::bstring arg0::bstring)
               (gtk (string-append "gtk_widget_show" " " arg0)) )
            
(define (gtk-server-callback::bstring)
      (gtk "gtk_server_callback WAIT"))

(define (gtk-server-update::bstring)
      (gtk "gtk_server_callback update"))
      
(define (gtk-frame-new::bstring)
      (gtk "gtk_frame_new NULL"))

(define (gtk-entry-new::bstring)
      (gtk "gtk_entry_new"))

     
(define (gtk-box-pack-start::bstring arg0::bstring  arg1::bstring 
                arg2::bool arg3::bool arg4::int)
          (gtk (string-append 
                   "gtk_box_pack_start"
                   " "
                   arg0
                   " "
                   arg1
                   " "
                   (if arg2 "1" "0")
                   " "
                   (if arg3 "1" "0")
                   " "
                   (number->string arg4))))
                  
(define (gtk-box-pack-end::bstring arg0::bstring  arg1::bstring 
                  arg2::bool arg3::bool arg4::int)
          (gtk (string-append 
                   "gtk_box_pack_start"
                   " "
                   arg0
                   " "
                   arg1
                   " "
                   (if arg2 "1" "0")
                   " "
                   (if arg3 "1" "0")
                   " "
                   (number->string arg4))))


(define (gtk-vbox-new::bstring arg0::bool arg1::int)
        (gtk (string-append
                  "gtk_vbox_new"
                  " "
                  (if arg0 "1" "0")
                  " "
                  (number->string arg1) ))) 

(define (gtk-hbox-new::bstring arg0::bool arg1::int)
        (gtk (string-append
                  "gtk_hbox_new"
                  " "
                  (if arg0 "1" "0")
                  " "
                  (number->string arg1) )))

 
(define (gtk-hseparator-new::bstring)
      (gtk "gtk_hseparator_new"))
      
(define (gtk-scrolled-window-new::bstring)
      (gtk  "gtk_scrolled_window_new NULL NULL"))


(define (gtk-text-buffer-new::bstring)
      (gtk  "gtk_text_buffer_new NULL"))

(define (gtk-text-view-new-with-buffer::bstring arg0::bstring)
        (gtk (string-append 
                "gtk_text_view_new_with_buffer" " " arg0)))

(define (gtk-text-view-set-editable::bstring tv::bstring yes::bool) 
       (gtk (string-append "gtk_text_view_set_editable"
             " "
             tv
             " "
             (if yes "1" "0") )))

(define (gtk-text-view-set-wrap-mode::bstring tv::bstring m::int)
      (gtk (string-append
           "gtk_text_view_set_wrap_mode"           
            " "
            tv
            " "
            (number->string m))))
            
(define (gtk-text-set-word-wrap::bstring txt::bstring m::int)
      (gtk (string-append
           "gtk_text_set_word_wrap"           
            " "
            txt
            " "
            (number->string m))))

(define (gtk-server-enable-c-string-escaping::bstring)
     (gtk  "gtk_server_enable_c_string_escaping"))


(define (gtk-server-disable-c-string-escaping::bstring)
     (gtk  "gtk_server_disable_c_string_escaping"))

(define (gtk-entry-get-text::bstring arg0::bstring)
         (gtk (string-append  "gtk_entry_get_text" " " arg0)))

   
(define (gtk-text-buffer-set-text::bstring wtx::bstring t::bstring sz::int)
     (gtk (string-append
              "gtk_text_buffer_set_text"
	       " "
	       wtx
	       " \"" 
	       t 
	       "\" "
	       (number->string sz))))

(define (gtk-text-buffer-delete::bstring arg0::bstring arg1::bstring arg2::bstring)
     (gtk (string-append
               "gtk_text_buffer_delete"
                                    " "
                                    arg0
                                    " "
                                    arg1
                                    " "
                                    arg2)))

                                    
(define (gtk-text-buffer-get-bounds::bstring arg0::bstring arg1::bstring arg2::bstring)
     (gtk (string-append
               "gtk_text_buffer_get_bounds"
                                    " "
                                    arg0
                                    " "
                                    arg1
                                    " "
                                    arg2)))

                             
(define (gtk-text-buffer-get-end-iter::bstring arg0::bstring arg1::bstring)
          (gtk (string-append 
                 "gtk_text_buffer_get_end_iter"
                                    " "
                                    arg0
                                    " "
                                    arg1)))
           
(define (gtk-text-buffer-get-text::bstring arg0::bstring
           arg1::bstring
           arg2::bstring
           arg3::bool)
        (gtk (string-append
                "gtk_text_buffer_get_text"
                                    " "
                                    arg0
                                    " "
                                    arg1
                                    " "
                                    arg2
                                    " "
                                    (if arg3 "1" "0"))))  
           
(define (gtk-text-buffer-get::bstring
           arg0::bstring
           arg1::bstring
           arg2::bstring
           arg3::bool)
      (gtk-server-enable-c-string-escaping)
      (let ( (contents (gtk-text-buffer-get-text arg0 arg1 arg2 arg3)))
          (gtk-server-disable-c-string-escaping)
          contents))

(define (gtk-text-buffer-insert::bstring
          arg0::bstring
          arg1::bstring
          arg2::bstring
          arg3::int)
        (gtk (string-append 
                   "gtk_text_buffer_insert"
                   " "
                   arg0
                   " "
                   arg1
                   " \"" arg2 "\" "
                   (number->string arg3))))

;;; Graphics start here!
(define gtk-image-set-from-pixmap
	 (lambda::bstring
	     (image::bstring pix::bstring)
	       (gtk (string-append "gtk_image_set_from_pixmap"
	                  " "
	                  image
	                  " "
	                  pix
	                  " "
	                  "NULL"))))
	                  

(define gdk-gc-new
     (lambda::bstring
        (arg0::bstring)
          (gtk  (string-append "gdk_gc_new"
                          " "
                          arg0))))
                          
(define gdk-pixmap-new
           (lambda::bstring
                   (arg0::bstring
                     arg1::int
                     arg2::int
                     arg3::int)
             (gtk  (string-append "gdk_pixmap_new"
                                    " "
                                    arg0
                                    " "
                                    (number->string arg1)
                                    " "
                                    (number->string arg2)
                                    " "
                                    (number->string arg3)))))
                                    
(define gtk-widget-get-parent-window
    (lambda::bstring
       (arg0::bstring)
          (gtk (string-append "gtk_widget_get_parent_window"
					   " "
					   arg0))))
					   
(define g-object-unref
     (lambda::bstring
	   (arg0::bstring)
        (gtk (string-append "g_object_unref" " " arg0))))
        

	                                  
(define gdk-color-parse
    (lambda::bstring
        (arg0::bstring arg1::bstring)
           (gtk (string-append "gdk_color_parse"
                                      " "
                                      arg0
                                      " "
                                      arg1))))
                                
(define gdk-gc-set-rgb-bg-color
     (lambda::bstring
	   (arg0::bstring arg1::bstring)
         (gtk (string-append "gdk_gc_set_rgb_bg_color"
	                                 " "
	                                 arg0
	                                 " "
	                                 arg1))))
	                                             
(define gdk-gc-set-rgb-fg-color
     (lambda::bstring
         (arg0::bstring arg1::bstring)
           (gtk (string-append "gdk_gc_set_rgb_fg_color"
				     " "
				     arg0
				     " "
				     arg1))))

(define gdk-draw-layout
   (lambda::bstring
     (pix::bstring gc::bstring x::int y::int w::bstring)
    (gtk (string-append "gdk_draw_layout" " " pix " " gc " "
              (number->string x) " " (number->string y) " "
               w))))

(define gtk-widget-create-pango-layout
   (lambda::bstring
     (img::bstring txt::bstring)
       (gtk (string-append "gtk_widget_create_pango_layout"  " "
              img " " txt))))
                                	
(define gdk-draw-rectangle
     (lambda::bstring
        (arg0::bstring arg1::bstring arg2::bool arg3::int
                  arg4::int arg5::int arg6::int)
          (gtk (string-append "gdk_draw_rectangle"
                                    " "
                                    arg0
                                    " "
                                    arg1
                                    " "
                                    (if arg2 "1" "0")
                                    " "
                                    (number->string arg3)
                                    " "
                                    (number->string arg4)
                                    " "
                                    (number->string arg5)
                                    " "
                                    (number->string arg6)))))

(define gdk-draw-line
    (lambda::bstring
       (arg0::bstring arg1::bstring  arg2::int arg3::int arg4::int arg5::int)
	    (gtk  (string-append "gdk_draw_line"
	                " "
	                arg0
	                " "
	                arg1
	                " "
	                (number->string arg2)
	                " "
	                (number->string arg3)
	                " "
	                (number->string arg4)
	                " "
	                (number->string arg5)))))
	                
(define gtk-event-box-new
     (lambda::bstring
         ()
        (gtk "gtk_event_box_new")))

(define gtk-image-new-from-file
       (lambda::bstring
            (arg0::bstring)
               (gtk (string-append "gtk_image_new_from_file"
                                    " \"" arg0 "\""))))

(define (gtk-image-new::bstring)
       (gtk "gtk_image_new"))
 
(define gtk-window-set-position
    (lambda::bstring
        (arg0::bstring arg1::int)
            (gtk (string-append "gtk_window_set_position"
                                    " "
                                    arg0
                                    " "
                                    (number->string arg1)))))

(define gtk-window-set-default-size
   (lambda::bstring
       (arg0::bstring arg1::int arg2::int)
          (gtk (string-append "gtk_window_set_default_size"
                                    " "
                                    arg0
                                    " "
                                    (number->string arg1)
                                    " "
                                    (number->string arg2)) )))

(define gtk-window-set-resizable
   (lambda::bstring
      (arg0::bstring arg1::bool)
         (gtk (string-append "gtk_window_set_resizable"
                                    " "
                                    arg0
                                    " "
                                    (if arg1 "1" "0")))))

(define gtk-text-buffer-remove-tag-by-name
     (lambda::bstring
         ( arg0::bstring
           arg1::bstring
           arg2::bstring
           arg3::bstring)
           (gtk (string-append "gtk_text_buffer_remove_tag_by_name"
                                    " "
                                    arg0
                                    " \""
                                    arg1
                                    "\" "
                                    arg2
                                    " "
                                    arg3))))
   
   
(define gtk-text-buffer-apply-tag-by-name
                  (lambda::bstring
                    (arg0::bstring
                      arg1::bstring
                      arg2::bstring
                      arg3::bstring)
         (gtk (string-append "gtk_text_buffer_apply_tag_by_name"
                                     " "
                                     arg0
                                     " \""
                                      arg1
                                     "\" "
                                     arg2
                                     " "
                                     arg3))))

(define gtk-text-buffer-create-tag
                 (lambda::bstring
                   (arg0::bstring
                     arg1::bstring
                     arg2::bstring
                     arg3::bstring)
        (gtk (string-append "gtk_text_buffer_create_tag"
                                    " "
                                    arg0
                                    " "
                                   "\"" arg1 "\""
                                    " "
                                   "\"" arg2 "\""
                                    " "
                                    "\"" arg3 "\""
                                    " "
                                    "NULL"))))

(define gtk-font-selection-new
                 (lambda::bstring
                   ()
       (gtk "gtk_font_selection_new") ))

(define gtk-font-selection-get-font-name
                 (lambda::bstring
                   (arg0::bstring)
      (gtk (string-append "gtk_font_selection_get_font_name"
                                    " "
                                    arg0))))

(define gtk-font-selection-dialog-new
      (lambda::bstring
          (arg0::bstring)
       (gtk (string-append "gtk_font_selection_dialog_new"
                                    " \""
                                    arg0 "\""))))
                                    
(define gtk-window-set-transient-for
        (lambda::bstring
            (arg0::bstring arg1::bstring)
              (gtk (string-append "gtk_window_set_transient_for"
                                    " "
                                    arg0
                                    " "
                                    arg1))))

(define gtk-message-dialog-new
                 (lambda::bstring
                   (arg0::bstring
                     arg1::int
                     arg2::int
                     arg3::int
                     arg4::bstring)
       (gtk (string-append "gtk_message_dialog_new"
                                    " "
                                    arg0
                                    " "
                                    (number->string arg1)
                                    " "
                                    (number->string arg2)
                                    " "
                                    (number->string arg3)
                                    " "
                                    "\""  arg4 "\"" )) ) )
                                    
                             
(define gtk-dialog-run
                 (lambda::bstring
                   (arg0::bstring)
          (gtk (string-append "gtk_dialog_run" " " arg0) ) ))
          
(define gdk-font-load
                 (lambda::bstring
                   (arg0::bstring)
     (gtk  (string-append "gdk_font_load"
                                    "  \"" arg0 "\""))))
                                    
(define gtk-widget-hide
                 (lambda::bstring
                   (arg0::bstring)
       (gtk (string-append "gtk_widget_hide" " " arg0))))
       

(define gtk-server-connect
                 (lambda::bstring
                   (arg0::bstring arg1::bstring)
          (gtk  (string-append "gtk_server_connect"
                                      " "
                                      arg0
                                      " "
                                     arg1 ))))
                               
(define gtk-get-mouse-button
    (lambda::int
       ()
       (string->integer (gtk "gtk_server_mouse 2"))))
       
       
(define gtk-mouse-x
    (lambda::int
       ()
       (string->integer (gtk "gtk_server_mouse 0"))))
       
(define gtk-mouse-y
    (lambda::int
       ()
       (string->integer (gtk "gtk_server_mouse 1"))))

(define gtk-image-set-from-file
   (lambda::bstring
      (img::bstring fname::bstring)
      (gtk (string-append "gtk_image_set_from_file" 
              "  " img " " fname))) )


(define gtk-server-timeout
   (lambda::bstring
      (tmp::int wid::bstring)
     (gtk (string-append "gtk_server_timeout"
              " " (number->string tmp) " "
                wid " show")) ) )

(define gtk-text-iter-forward-search
          (lambda::bool
              ( arg0::bstring
                arg1::bstring
                arg2::int
                arg3::bstring
                arg4::bstring)
       (equal? "1"    (gtk (string-append "gtk_text_iter_forward_search"
                                    " "
                                    arg0
                                    " "
                                    "\"" arg1 "\""
                                    " "
                                    (number->string arg2)
                                    " "
                                    arg3
                                    " "
                                    arg4
                                    " "
                                    "NULL")))) )

(define gtk-text-buffer-select-range
          (lambda::bstring
             (arg0::bstring arg1::bstring arg2::bstring)
             (gtk (string-append "gtk_text_buffer_select_range"
                                    " "
                                    arg0
                                    " "
                                    arg1
                                    " "
                                    arg2) )))
(define gtk-text-buffer-get-start-iter
          (lambda::bstring
             (arg0::bstring arg1::bstring)
                (gtk (string-append "gtk_text_buffer_get_start_iter"
                                    " "
                                    arg0
                                    " "
                                    arg1) ) ) )


(define gtk-text-iter-forward-visible-cursor-position
                 (lambda::bool
                   (arg0::bstring)
       (equal? "1"   (gtk (string-append "gtk_text_iter_forward_visible_cursor_position"
                                    " "
                                    arg0) )) ) )


(define gtk-text-buffer-create-mark
          (lambda::bstring
           ( arg0::bstring
             arg1::bstring
             arg2::bstring
             arg3::bool)
   (gtk (string-append "gtk_text_buffer_create_mark"
                                    " "
                                    arg0
                                    " "
                                    "\""  arg1  "\""
                                    " "
                                    arg2
                                    " "
                                    (if arg3 "1" "0")) )) )
                             
                             
(define gtk-text-buffer-get-iter-at-mark
     (lambda::bstring
       (arg0::bstring arg1::bstring arg2::bstring)
          (gtk (string-append "gtk_text_buffer_get_iter_at_mark"
                                    " "
                                    arg0
                                    " "
                                    arg1
                                    " "
                                    arg2))))
                     
                     
(define gtk-text-buffer-delete-mark
    (lambda::bstring
       (arg0::bstring arg1::bstring)
           (gtk (string-append "gtk_text_buffer_delete_mark"
                                    " "
                                    arg0
                                    " "
                                    arg1) ) ))
                      
                      
(define gtk-text-buffer-delete-mark-by-name
     (lambda::bstring
         (arg0::bstring arg1::bstring)
           (gtk (string-append "gtk_text_buffer_delete_mark_by_name"
                                    " "
                                    arg0
                                    " "
                                    "\"" arg1 "\""))))
                                    
                             
(define gtk-text-buffer-get-selection-bounds
          (lambda::bool
             (arg0::bstring arg1::bstring arg2::bstring)
               (equal? "1" (gtk (string-append "gtk_text_buffer_get_selection_bounds"
                                    " "
                                    arg0
                                    " "
                                    arg1
                                    " "
                                    arg2)))))
                                    

(define gtk-entry-set-text
   (lambda::bstring
     (arg0::bstring arg1::bstring)
       (gtk (string-append "gtk_entry_set_text"
                                    " "
                                    arg0
                                    " "
                                    "\"" arg1 "\"")) ))

                             
(define gtk-file-chooser-get-filename
                 (lambda::bstring
                   (arg0::bstring)
         (gtk (string-append "gtk_file_chooser_get_filename" " " arg0))) )
         


(define gtk-file-chooser-widget-new
          (lambda::bstring
            (arg0::int)
               (gtk (string-append "gtk_file_chooser_widget_new"
                                    " "
                                    (number->string arg0)))))
                                    
(define gtk-file-filter-new
                 (lambda::bstring
                   ()
     (gtk (string-append "gtk_file_filter_new") )))
   

(define gtk-file-filter-add-pattern
     (lambda::bstring
          (arg0::bstring arg1::bstring)
               (gtk (string-append "gtk_file_filter_add_pattern"
                                    " "
                                    arg0
                                    " "
                                    "\"" arg1 "\"") )))

(define gtk-file-filter-set-name
           (lambda::bstring
              (arg0::bstring arg1::bstring)
                 (gtk (string-append "gtk_file_filter_set_name"
                                    " "
                                    arg0
                                    " "
                                    "\"" arg1 "\""))))
                             
(define gtk-file-chooser-add-filter
           (lambda::bstring
               (arg0::bstring arg1::bstring)
                 (gtk (string-append "gtk_file_chooser_add_filter"
                                    " "
                                    arg0
                                    " "
                                    arg1) )) )


(define gtk-file-chooser-set-filename
         (lambda::bool
            (arg0::bstring arg1::bstring)
               (equal? "1" (gtk (string-append "gtk_file_chooser_set_filename"
                                    " "
                                    arg0
                                    " "
                                    "\"" arg1 "\"" ))))   )
                             

(define (gtk-load-lines fname)
  (if (file-exists? fname)
    (call-with-input-file fname 
      (lambda(in)
       (let ( (resp '()))
        (do ( (i (read-line in) (read-line in)))
            ( (eof-object? i) (close-input-port in) (reverse resp))
            
            (set! resp (cons  (string-append    (string-for-read i)  "\\n") resp))
           
            
            )
         
       )
     )
   )
  '("File does not exist!")
))


(define (gtk-text-buffer-get-list txt startit endit)
   (gtk-text-buffer-get-bounds txt startit endit)
   (let* ( (s (gtk-text-buffer-get txt startit endit #t))
           (pin (open-input-c-string s)))
        (string-split (read pin) "\n")))
	        
(define (gtk-save-buffer txt file-name startit endit)
   (gtk-text-buffer-get-bounds txt startit endit)
   (let ( (s  (gtk-text-buffer-get txt startit endit #t) ))
     (call-with-output-file file-name 
       (lambda(out)
         (let ((pin (open-input-c-string s)))
           (display (read pin) out)
           (close-output-port out))) )) )

(define (gtk-ins-lines xs buffer nd)
  (gtk-text-buffer-set-text  buffer "" -1)
  (for-each (lambda(x) (gtk-text-buffer-get-end-iter buffer nd)
                       (gtk-text-buffer-insert buffer nd x  -1))
            xs))                      

(define gtk-menu-bar-new
        (lambda::bstring
            ()  
     (gtk (string-append "gtk_menu_bar_new") ))  )
     
(define gtk-menu-new
    (lambda::bstring
       ()
      (gtk (string-append "gtk_menu_new"))))

(define gtk-menu-item-new
     (lambda::bstring
        ()
       (gtk  (string-append "gtk_menu_item_new") )))
                                  
(define gtk-menu-item-new-with-label
     (lambda::bstring
        (arg0::bstring)
       (gtk (string-append "gtk_menu_item_new_with_label"
                                    " "
                                  "\""  arg0  "\"" )) ))
                             
(define gtk-menu-shell-append
         (lambda::bstring
           (arg0::bstring arg1::bstring)
             (gtk (string-append "gtk_menu_shell_append" " " arg0 " " arg1))))
                           
(define gtk-menu-item-new-with-mnemonic
     (lambda::bstring
         (arg0::bstring)
           (gtk (string-append "gtk_menu_item_new_with_mnemonic"
                                    " "
                                    "\""  arg0 "\"" ))))

(define gtk-menu-item-set-submenu
     (lambda::bstring
         (arg0::bstring arg1::bstring)
            (gtk (string-append "gtk_menu_item_set_submenu"
                                    " "
                                    arg0
                                    " "
                                    arg1) ) ) )
                                                    
(define (pack-homogeneously hbx . components)
   (do ( (c components (cdr c)))
       ((null? c))
       (gtk-box-pack-start hbx (car c) 1 1 0)))

(define (pack-pack vbx . components)
   (do ( (c components (cdr c)))
       ((null? c))
       (gtk-box-pack-start vbx (car c) 0 0 1)))




(define (begin0 x . body) x)
         
(define (expression->string s)
	(let* ( ( porta (open-output-string)))
	      (display s porta)
              (close-output-port porta)
	)
)


(define (string->expression s)
   (let* ( (pin (open-input-c-string  s))
           (res (read pin))
            ) 
       res
) )
       
(define (expression->pretty s)
    (let ( (pout (open-output-string)))
      (pp  s pout)
       (string-for-read (close-output-port pout))   ))

(define (append-list xs)
   (cond ((null? xs) "")
         (else (string-append (car xs) (append-list (cdr xs))) )
   )
)


