
(define *ld-post-options* "")

;*---------------------------------------------------------------------*/
;*    The basename of the gtkserver native library name                */
;*---------------------------------------------------------------------*/
(cond-expand
   (bigloo-c
    (library-translation-table-add! 'gtkserver "bigloogtkserver"))
   (bigloo-jvm
    (library-translation-table-add! 'gtkserver "bigloo/gtkserver/make-lib" #f))
   (else
    #unspecified))
   
;*---------------------------------------------------------------------*/
;*    Link option                                                      */
;*---------------------------------------------------------------------*/
(cond-expand
   (bigloo-compile
    (set! *ld-post-options* (string-append "-lgtk-server " *ld-post-options*)))
   (bigloo-eval
    #unspecified))

(define-syntax make-cond
  (syntax-rules (else)
     ( (make-cond ev else) #t )
     ( (make-cond ev x)  (equal? ev x)) ))

(define-syntax play-with
   (syntax-rules (equal? or until thus)
      ( (play-with ev until (equal? ev x) thus  (cs . e)...   )
        (do ((ev (gtk-server-callback) (gtk-server-callback)))
            ((equal? ev x)) (cond ((make-cond ev cs) . e)...) ))
      ( (play-with ev until (or (equal? ev x) . stop-conditions) thus  (cs . e)...   )
        (do ((ev (gtk-server-callback) (gtk-server-callback)))
            ((or (equal? ev x) . stop-conditions)) (cond ((make-cond ev cs) . e)...) ))
      ( (play-with ev until condition-met . body) 
        (do ( (ev (gtk-server-callback) (gtk-server-callback)))
            ( condition-met) . body) )
)   )
            
     
(define-syntax next-search
   (syntax-rules ()
      ( (next-search entr buffer mark from start nd)
        (let ( (search-string (gtk-entry-get-text entr)))
           (cond ( mrk
	          (gtk-text-buffer-get-iter-at-mark buffer from mark)
	          (gtk-text-buffer-get-iter-at-mark buffer start mark)
	          (gtk-text-buffer-get-iter-at-mark buffer nd mark))
	        (else
	          (gtk-text-buffer-get-start-iter buffer nd)
	          (gtk-text-buffer-get-start-iter buffer start)
                  (gtk-text-buffer-get-start-iter buffer from)) )
           (set! fnd (gtk-text-iter-forward-search from search-string 0 start nd))    
	   (when fnd (gtk-text-buffer-select-range buffer start nd))
           (set! mrk (gtk-text-buffer-create-mark buffer "next" nd #t))))
))


(define-syntax first-search
   (syntax-rules ()
      ( (first-search entr buffer from start nd)
        (let ( (search-string (gtk-entry-get-text entr)))
            (gtk-text-buffer-get-start-iter buffer nd)
	    (gtk-text-buffer-get-start-iter buffer start)
            (gtk-text-buffer-get-start-iter buffer from)
           (set! fnd (gtk-text-iter-forward-search from search-string 0 start nd))    
	   (when fnd (gtk-text-buffer-select-range buffer start nd))
           (set! mrk (gtk-text-buffer-create-mark buffer "next" nd #t))))
))

