;; bigloo -o sca-bttn.exe sca-bttn.scm gtk.o -lgtk-server

(module test  (main start)
   (include "macro-def.sch")
   (import (gtkserver_gtk "gtk.scm")) )

(define (start argv)
  (gtk-init)
  (let [  (w (gtk-window-new 0))
          (hbx (gtk-hbox-new #t 0))
          (do-button (gtk-button-new-with-label "Hello"))
          (exit-button (gtk-button-new-with-label "Exit"))
       ]
          
     (gtk-box-pack-start hbx exit-button 1 1 0)
     (gtk-box-pack-start hbx do-button 1 1 0)
     (gtk-container-add  w hbx)
     (gtk-widget-show-all w)
     (do  ([event (gtk-server-callback) (gtk-server-callback)] )
          ([equal? event exit-button])
       (when (equal? event do-button)
             (print "Hello, world!")
             (flush-output-port (current-output-port)) )
     ); end do
   ); end let
); end define


;; In this program, you will put a dialog button to work. If the user
;; presses the exit button, s/he will attribute "button" to  event; this
;; will make the clause (equal? event button) be true (or #t, in Scheme).
;; The result is that the server will interrupt the do loop:
;;
;;       (do ((event (gtk-server-callback) 
;;              (gtk-server-callback)) )
;;           ((equal? event button))
;;
;; The clause ((event (gtk-server-callback) (gtk-server-callback))) initializes
;; the variable 'event' to the value returned by (gtk-server-callback);
;; the next time that it goes through the do loop, the server updates
;; 'event' to a new value. Events produced by (gtk-server-callback) are
;; things like button pressed, or mouse clicked.

;; Designing and building the interface is quite intuitive. You need to
;; create a window, and store it in the variable 'w'.
;;
;;       (w (gtk-window-new 0))
;;
;; Then, you need to create a container, to hold components like buttons,
;; and edit fields. In the present case, the container is called 'hbx'.
;;
;;                  (hbx (gtk-hbox-new #f 0))
;;
;; Youcan view hbx as ashelf that holds the exit-button and the do-button.
;; In the body of the let, both buttons will bepacked into hbx.
;; In its turn, hbx will be added to the 'w' window.
;;
;;             (gtk-box-pack-start hbx exit-button 1 1 0)
;;             (gtk-container-add  w hbx)
;;             (gtk-widget-show-all w)
;;
;; Up to this point, we have mounted a window, with a horizontal box that 
;; holds two buttons. Now, we must request that the computer shows this 
;; window. This can be accomplished by the following command:
;;
;;        (gtk-widget-show-all win)
;;
;; To close this program, we will put the 'gtk-server' in a loop that will
;; last until someone presses the exit-button.
;;
;; (do  ([event (gtk-server-callback) (gtk-server-callback)] )
;;      ([equal? event exit-button])
;;   (when (equal? event do-button)
;;             (print "Hello, world!")
;;             (flush-output-port (current-output-port)) )
;; ); end do
;;
;; You may be wondering why the box creation function has two arguments, 
;; that in 'sca-bttn' were set to '#f' and 0. The second argument sets the 
;; distance between one of the box components and the next. In this case, 
;; it sets the distance between one button and the other. If the first argument 
;  is true, the program will give both buttons the same width. From  "scb-bttn",
;  you can see what happens if one uses the following settings for 'hbx:
;;
;;                  (hbx (gtk-hbox-new #t 20))
