;; bigloo -o scc-argv.exe scc-argv.scm gtk.o  -lgtk-server

(module command-line (main main)
  (include "macro-def.sch")
  (import (gtkserver_gtk "gtk.scm")))

(define (main argv)
  (gtk-init)
  (let* ( (win (gtk-window-new 0))
          (hbx (gtk-hbox-new #f 0))
          (button (gtk-button-new-with-label (read-exit argv))))
          
     (gtk-box-pack-start hbx button 1 1 0)
     (gtk-container-add  win hbx)
     (gtk-widget-show-all win)
     (play-with event until (equal? event button))
   ); end let*
); end define

(define (read-exit xs)
  (with-handler (lambda(e) "Exit")
       (cadr xs))  )
       
;; This program shows how to read the label of the exit button (or anything
;; else) from the command line. The argument of function main points to a
;; list with the works (tokens) of the command line. Function (read-exit xs)
;; gets the second element of foresaid list; one must take the second argument
;; because the first place is reserved for the program. For instance, if you type
;;
;;   $ scc-argv bye
;;
;; the list will be ("scc-argv" "bye"). What happens is the user forgets to
;; type the second argument? In this case, the function (with-handler ...)
;; captures the error and provides a default solution: "Exit".