;; File std.scm
;  Compile: bigloo -o scd-nobang scd-nobang.scm  -lgtk-server

(module test (main start-here)
  (include "macro-def.sch")
  (import (gtkserver_gtk "gtk.scm")))

(define (get-int entr)
  (with-handler (lambda(e) 0)
   (string->number (gtk-entry-get-text entr)) ) )

(define (start-here argv)
  (gtk-init)
  (let* [ (win (gtk-window-new 0))
          (hbx (gtk-hbox-new #f 0))
          (vbx (gtk-vbox-new #f 0))
          (entr (gtk-entry-new))
          (ext (gtk-button-new-with-label "exit"))
          (fact (gtk-button-new-with-label "!"))
        ]
     
      (gtk-box-pack-start hbx entr 1 1 0)
      (gtk-box-pack-start hbx fact 1 1 0)
     
      (gtk-box-pack-start vbx  ext 1 1 0)
      (gtk-box-pack-start vbx hbx 1 1 0)
     
      (gtk-container-add  win vbx)
      (gtk-widget-show-all win)
      (do ( [event (gtk-server-callback) (gtk-server-callback)]
            [data (get-int entr) (get-int entr)] )
          ((equal? event ext))
         (when (equal? event fact)
            (gtk-entry-set-text entr 
                  (number->string (factorial data)  ))
         ); end when 
       ); end do 
    ); end let*   
); end define

(define (factorial n)
  (if (< n 1) 1
      (* n (factorial (- n 1)))))
      

;;;;;;;;;;;;;;;;;;;  No bang means elegance ;;;;;;;;;;;;;;;;;;
;;
;; In program "scd-factorial.scm", we have made use of the attribution command:
;;     
;;           (set! data (string->number (gtk-entry-get-text entr)))
;;
;; The set! (pronounced set bang) command is the assignment operator in scheme. 
;; Scheme is a functional language, and functional languages should do without 
;; assignment; after all, assignments are dangerous, and destroy the mathematica
;; purity of the language. The only reason for using it in "scd-factorial.scm"
;; factorial, and return the result to the data entry. Therefore, if you 
;; was to show you the 'play-with' form. Here you will see that by using the 
;; 'do'-macro you can get rid of the nasty command. At each instance of the loop,
;; the variable 'data' is updated to a new number from the 'entr'-field.

