;;
;; Compile with:
;;
;;	bigloo -o sch-font sch-fonts.scm gtk.o -lgtk-server
;;

(module test (main main)
  (include "macro-def.sch")
  (import (gtkserver_gtk "gtk.scm")))
    
(define (main arqv)
  (gtk-init)
  (let* ( (win::string (gtk-window-new 0))
          (_ (gtk-window-set-default-size win 600 480))
          (fnt-win (gtk-window-new 0))
          (_ (gtk-window-set-transient-for fnt-win win))
          (tbl::string  (gtk-table-new 20 20 1))
          (startit::string (gtk-frame-new))
          (endit::string   (gtk-frame-new))
          (fntstart (gtk-frame-new))
          (fntend   (gtk-frame-new))
          (ext::string  (gtk-button-new-with-label "Exit")) 
          (sav::string  (gtk-button-new-with-label "Save"))
          (lod::string  (gtk-button-new-with-label "Load"))
          (fok (gtk-button-new-with-label "Ok"))
          (fcan (gtk-button-new-with-label "Cancel"))
          (fnt-button::string  (gtk-button-new-with-label "Font"))
          (en::string (gtk-entry-new))
          (hbx::string (gtk-hbox-new #f 0))
          (vbx::string (gtk-vbox-new #f 2)) 
          (font_vbox (gtk-vbox-new #f 0))
          (font_hbox (gtk-hbox-new #f 0))
          (sep  (gtk-hseparator-new)) 
          (sw (gtk-scrolled-window-new))
          (txt (gtk-text-buffer-new))
          (tv (gtk-text-view-new-with-buffer txt))
          
          (fsel (gtk-font-selection-new))
          (fnt-nm "")
          (fntname "")
          (fname "")  
          (kw "")         )
    
     (gtk-box-pack-start hbx ext 0 0 1)
     (gtk-box-pack-start hbx sav 0 0 1)
     (gtk-box-pack-start hbx lod 0 0 1)
     (gtk-box-pack-start hbx fnt-button 0 0 1)   
     (gtk-box-pack-start vbx hbx 0 0 1)
     (gtk-box-pack-start vbx sep 0 0 1)
     (gtk-box-pack-start vbx en 0 1 1) 
     
     (gtk-container-add sw tv)
     (gtk-table-attach-defaults tbl vbx 0 10 0 4 )
     (gtk-table-attach-defaults tbl sw 0 19 5 19)
	   
     (gtk-text-view-set-editable tv 1)
     (gtk-text-view-set-wrap-mode tv 2)
	  
     (gtk-container-add  win tbl)
     (gtk-window-set-title win "Demo with GTK-server lib")  
     (gtk-widget-show-all win)
     
     (gtk-box-pack-end font_hbox fok 0 0 1)
     (gtk-box-pack-end font_hbox fcan 0 0 1)
     (gtk-box-pack-start font_vbox fsel 1 1 1)
     (gtk-box-pack-start font_vbox font_hbox 0 0 1)
     (gtk-container-add fnt-win font_vbox)
     
     
     (do ((event (gtk-server-callback) 
	         (gtk-server-callback)) )
        ((equal? event ext))
        (cond ( (equal? event sav)
                (set! fname (gtk-entry-get-text en))                    
                (set! fname (if (< (string-length fname) 2) 
                                    "backup.txt" fname))
	        (gtk-save-buffer txt fname startit endit)
	        )
	      ( (equal? event fok)
	        (set! fnt-nm (gtk-font-selection-get-font-name fsel))
	        
	        (gtk-text-buffer-get-bounds txt fntstart fntend)
                (when (not (equal? fntname ""))
	             (gtk-text-buffer-remove-tag-by-name txt fntname fntstart fntend))
                (set! fntname (symbol->string (gensym "font")))
                (gtk-text-buffer-create-tag txt fntname "font" fnt-nm)
                
                (gtk-text-buffer-get-bounds txt fntstart fntend)
                (gtk-text-buffer-apply-tag-by-name txt fntname fntstart fntend)
	        (gtk-widget-hide fnt-win))
	      ( (equal? event fnt-button)
	        (gtk-widget-show-all fnt-win) )
	       
	      ( (equal? event lod)
	        (set! fname (gtk-entry-get-text en))
		(gtk-text-buffer-set-text  txt "" -1)
                (let again ( (xs (gtk-load-lines fname)))
                     (when (not (null? xs))
                     (gtk-text-buffer-get-end-iter txt endit)
                     (gtk-text-buffer-insert txt endit  (car xs)  -1) 
                     (again (cdr xs))))) )
		          
                
	        
)))



;; The only difference between the present program (sch-fonts.scm)
;; and the previous one (scg-edit.scm) is the change font button.
;; When one presses the 'Font' button, a font change dialog pops up.
;; In the font change dialog, if one presses the fok button, the
;; following operations take place:
;;
;;       (  (equal? event fok)
;;          (set! fnt-nm (gtk-font-selection-get-font-name fsel))  
;;          (gtk-text-buffer-get-bounds txt fntstart fntend)
;;          (when (not (equal? fntname ""))
;;              (gtk-text-buffer-remove-tag-by-name txt fntname fntstart fntend))
;;          (set! fntname (symbol->string (gensym "font")))
;;          (gtk-text-buffer-create-tag txt fntname "font" fnt-nm)
;;          (gtk-text-buffer-get-bounds txt fntstart fntend)
;;          (gtk-text-buffer-apply-tag-by-name txt fntname fntstart fntend)
;;          (gtk-widget-hide fnt-win)  )
;;
;; The '(set! fnt-nm (gtk-font-selection-get-font-name fsel))' stores the
;; font name into the 'fnt-nm' variable.  The command
;;
;;          (gtk-text-buffer-get-bounds txt fntstart fntend)
;;
;; gets the bounds of the text. Then one removes any previous font tag:
;;
;; (gtk-text-buffer-remove-tag-by-name txt fntname fntstart fntend)
;;
;; The next step is to create a tag for the new font; the name of the new tag
;; must be different of any previous name:
;; 
;;          (set! fntname (symbol->string (gensym "font")))
;;
;; It is necessary to create a tag with the new font. The name of the tag is
;; stored at 'fntname', and the name of the font is stored at 'fnt-nm'.
;;
;; (gtk-text-buffer-create-tag txt fntname "font" fnt-nm) 
;; 
;; Finally, one must find the bounds of the text, and set the new font:
;;
;;   (gtk-text-buffer-get-bounds txt fntstart fntend)
;;          (gtk-text-buffer-apply-tag-by-name txt fntname fntstart fntend)
;;          (gtk-widget-hide fnt-win) 
