;;
;; Compile with:
;;
;;	bigloo -o sci-mouse sci-mouse.scm gtk.o -lgtk-server
;;


(module mus (main main)
  (include "macro-def.sch")
  (import (gtkserver_gtk "gtk.scm")))

(define (main args)
    (gtk-init)
    (let* ( (win (gtk-window-new 0)) ; 0 means TOP WINDOW
                              
            ;; Create widget to display image
            (image (gtk-image-new)) 
                         
            ;; Create eventbox 
	    (EBOX (gtk-event-box-new))
	    (_ (gtk-container-add EBOX image))
               
            (xsize 400)
	    (ysize 400)
               
            (cor "#ff0000")
            (ext  (gtk-button-new-with-label "Exit"))
            (red  (gtk-button-new-with-label "Red"))
	    (green  (gtk-button-new-with-label "Green"))
	    (blue  (gtk-button-new-with-label "Blue"))
	                   
	    (hbx (gtk-hbox-new #f 0))
	    (vbx (gtk-vbox-new #f 2))
            (sep  (gtk-hseparator-new))
            (_(gtk-box-pack-start hbx ext 0 0 1))
            (_(gtk-box-pack-start hbx red 0 0 1))
	    (_(gtk-box-pack-start hbx green 0 0 1))
	    (_(gtk-box-pack-start hbx blue 0 0 1))
	       	   
	    (_(gtk-box-pack-start vbx hbx 0 0 1))
	    (_(gtk-box-pack-start vbx sep 0 0 1))
	    (_(gtk-box-pack-start vbx EBOX 1 1 1))
	   
	    (_(gtk-container-add win vbx ))
               
            (_(gtk-widget-show-all win)  )
            (gdkwin (gtk-widget-get-parent-window image))
            
	    (PIX (gdk-pixmap-new gdkwin xsize ysize -1))
	    (GC (gdk-gc-new PIX))
	    (_ (gtk-image-set-from-pixmap image PIX))
	    (layout (gtk-widget-create-pango-layout image "Hello"))
            (COLOR (gtk-frame-new)))
	   	   
	   (gtk-window-set-resizable win #t)
	   (gtk-window-set-default-size win 600 400)
	   (gtk-window-set-position win 1)
	   
	   (gtk-window-set-title win "Mouse example!")
          
           (gtk-server-connect EBOX "button-press-event canvas")
                    
           (do  ( (event (gtk-server-callback) (gtk-server-callback)))
                ( (equal? ext event) (print "Good bye!"))
               (cond ( (equal? red event) 
                       (set! cor "#ff0000") )
                     ( (equal? green event) 
                       (set! cor "#00ff00") )
                     ( (equal? blue event) 
                       (set! cor "#0000ff") )
                     ( (equal? event "canvas")
                         (g-object-unref PIX)
	                 (set! PIX (gdk-pixmap-new gdkwin xsize ysize -1))
		         (gtk-image-set-from-pixmap image PIX)
		       (if (equal? (gtk-get-mouse-button) 256)
			 (gdk-color-parse cor COLOR)
			 (gdk-color-parse "#ff0000" COLOR))
                       (gdk-gc-set-rgb-fg-color GC COLOR)
                       (gdk-draw-layout PIX GC (+ 20 (gtk-mouse-x)) (gtk-mouse-y) layout)
                       (gdk-draw-rectangle PIX GC #t (gtk-mouse-x) (gtk-mouse-y) 10 10) )
                );close cond
             );close do   
       );close let*
); close define 

