;;
;; Compile with:
;;
;;	bigloo -o worm scl-worm.scm gtk.o -lgtk-server
;;


(module mus (main main)
  (include "macro-def.sch")
  (import (gtkserver_gtk "gtk.scm")))

(define cor "#ff0000")
(define energy 100)

(define (main args)
    (gtk-init)
    (let* ( (win (gtk-window-new 0)) ; 0 means TOP WINDOW
                              
            ;; Create widget to display image
            (image (gtk-image-new)) 
                         
            ;; Create eventbox 
	    (EBOX (gtk-event-box-new))
	    (_ (gtk-container-add EBOX image))
               
            (xsize 400)
	    (ysize 400)
            (winId "")
            (ext  (gtk-button-new-with-label "Exit"))
            (rt  (gtk-button-new-with-label "Right"))
	    (lt  (gtk-button-new-with-label "Left*"))
	    (up  (gtk-button-new-with-label "*Up**"))
	    (dn  (gtk-button-new-with-label "Down*"))
	    
	    (hbx (gtk-hbox-new #f 0))
	    (vbx (gtk-vbox-new #f 2))
            (sep  (gtk-hseparator-new))
            (_(gtk-box-pack-start hbx ext 0 0 1))
            (_(gtk-box-pack-start hbx rt 0 0 1))
	    (_(gtk-box-pack-start hbx lt 0 0 1))
	    (_(gtk-box-pack-start hbx up 0 0 1))
	    (_(gtk-box-pack-start hbx dn 0 0 1))
	    
	    (_(gtk-box-pack-start vbx hbx 0 0 1))
	    (_(gtk-box-pack-start vbx sep 0 0 1))
	    (_(gtk-box-pack-start vbx EBOX 1 1 1))
	   
	    (_(gtk-container-add win vbx ))
               
            (_(gtk-widget-show-all win)  )
            (gdkwin (gtk-widget-get-parent-window image))
            
	    (PIX (gdk-pixmap-new gdkwin xsize ysize -1))
	    (GC (gdk-gc-new PIX))
	    (_ (gtk-image-set-from-pixmap image PIX))
	
            (COLOR (gtk-frame-new)))
	   	   
	   (gtk-window-set-resizable win #t)
	   (gtk-window-set-default-size win 600 400)
	   (gtk-window-set-position win 1)
	   
	   (gtk-window-set-title win "Mouse example!")
          
           (gtk-server-connect EBOX "button-press-event canvas")
           (gtk-server-connect EBOX "motion-notify-event motion")
           (gtk-server-connect win "show winId")
           
           (gtk-server-timeout 200 win)
           
           (init-worm)
           
           (do ( (event (gtk-server-callback) (gtk-server-callback)))
               ( (end-of-game crashed (< energy 0) (equal? ext event)) )
               
               (cond ( (equal? rt event) (wd 12 0)) 
                     ( (equal? lt event) (wd -12 0)) 
                     ( (equal? up event) (wd 0 -12)) 
                     ( (equal? dn event) (wd 0 12)) 
                     ( else ;(equal? "winId" event)
                       (g-object-unref PIX) ; (sleep 200000)
                       (move-worm 10 0 xsize ysize)
                       (when (< energy 40) (set! cor "#0000ff"))
                       (gdk-color-parse cor COLOR)
                       (gdk-gc-set-rgb-fg-color GC COLOR)
                       (set! PIX (gdk-pixmap-new gdkwin xsize ysize -1))
                       (gdk-color-parse cor COLOR)
                       (gdk-gc-set-rgb-fg-color GC COLOR)
                       (set! PIX (gdk-pixmap-new gdkwin xsize ysize -1))
                       (draw-obstacles  PIX GC)
                       (draw-food  PIX GC)
                       (draw-worm PIX GC)
                       (gtk-image-set-from-pixmap image PIX) ) )
             );close do   
       );close let*
); close define 

(define crashed #f)

(define (end-of-game crash energy exit)
   (cond (crash (print "CRASH!!!") #t)
         (energy (print "Energy shOrTaGe!") #t)
         (exit (print "Good bye!") #t)
         (else #f)))

(define (worm-dir)
  (let ( (x 12)
         (y 0))
     (lambda xy
        (cond ( (null? xy) (list x y))
              ( (null? (cdr xy)) (list x y))
              ( (and (number? (car xy))
                     (number? (cadr xy)))
                (set! x (car xy))
                (set! y (cadr xy))
                (list x y)) 
              (else (list x y)) )) ))
                
(define wd (worm-dir))
                
(define worm (make-vector 7))

(define (fun x)
   (let ( (cnt x))
      (lambda(y) (set! x (+ x y)) )) )

(define (init-worm) 
   (do ( (i (- (vector-length worm) 1) (- i 1)) )
       ( (< i 0) )
       (vector-set! worm i (list (- 60 (* i 12)) 100))
       ) )
 
(define (draw-worm pix gc)
    (do ( (i 0 (+ i 1)) )
       ( (>= i (vector-length worm)))
       (let ( (v (vector-ref worm i))) 
       (gdk-draw-rectangle pix gc #t (car v) (cadr v) 10 10)
       ) ) ) 
       
(define (move-worm dx dy xsize ysize)
  (let* ( (xy (wd))
          (delta-x (car xy))
          (delta-y (cadr xy))
          (head (vector-ref worm 0)) ) 
      (do ( (i (- (vector-length worm) 1) (- i 1)) )
          ( (< i 1) 
            (update-energy (got-food? head food))
            (set! crashed (or (in-obs? head obstacles)
                               (< (car head) 0)
                               (> (car head) xsize)
                               (< (cadr head) 0)
                               (> (cadr head) ysize)))
            (vector-set! worm 0 (list (+ delta-x (car head)) 
                                      (+ delta-y (cadr head)))) )
          (vector-set! worm i (vector-ref worm (- i 1)))
          
      ) 
  )
) 
      
      
(define obstacles
   ' ((200 120  90 100)
        (60 280  60 80)))

(define food
   ' ((180 290 20 20)
        (290 300  20 20)))

(define (draw-food pix gc)
  (for-each 
    (lambda(b) 
        (gdk-draw-rectangle pix gc #t 
             (car b) 
             (cadr b) 
             (caddr b)
             (cadddr b) )) food))


(define (draw-obstacles pix gc)
  (for-each 
    (lambda(b) 
        (gdk-draw-rectangle pix gc #f 
             (car b) 
             (cadr b) 
             (caddr b)
             (cadddr b) )) obstacles))
   
(define (in-obstacle? head ob)
  (let* ( (x1 (car ob))
         (y1 (cadr ob))
         (x2 (+ (caddr ob) x1) )
         (y2 (+ (cadddr ob) y1) ) 
         (hx (+(car head)6))
         (hy (+ (cadr head)6) ) )
      (and (> hx x1) (< hx x2)
           (> hy y1) (< hy y2)) ) )

(define (in-obs? head xs)
   (cond ( (null? xs) #f)
         ( (in-obstacle? head (car xs)) #t)
         (else (in-obs? head (cdr xs))) ))

(define (found-food? head ob)
  (let* ( (x1 (car ob))
         (y1 (cadr ob))
         (x2 (+ (caddr ob) x1) )
         (y2 (+ (cadddr ob) y1) ) 
         (hx (+(car head)6))
         (hy (+ (cadr head)6) ) )
      (and (> hx x1) (< hx x2)
           (> hy y1) (< hy y2)) ) )

(define (got-food? head xs)
   (cond ( (null? xs) #f)
         ( (found-food? head (car xs)) #t)
         (else (got-food? head (cdr xs))) ))

(define (update-energy x)
   (cond ( x (set! cor "#ff0000")
             (set! energy (+ energy 40)))
         (else (set! energy (- energy 1)))
   );close cond
);close define

