;;
;; Compile with:
;;
;;	bigloo -o scn-edit scn-edit.scm gtk.o -lgtk-server
;;

(module test (main main)
  (include "macro-def.sch")
  (import (gtkserver_gtk "gtk.scm")))
    
(define (main arqv)
  (gtk-init)
  (let* [ (win (gtk-window-new 0)) 
          
          ;; Three buttons to go with it.
          (ext  (gtk-button-new-with-label "Exit")) 
	  (sav  (gtk-button-new-with-label "Save"))
          (lod  (gtk-button-new-with-label "Load"))
          
          ;; A data entry.
          (en   (gtk-entry-new))
          
          ;; and a separator.
          (sep  (gtk-hseparator-new))
          
          ;; Horizontal box to hold the buttons.
          (hbx  (gtk-hbox-new #f 0))
          
          ;; The row of buttons, the data entry, and the separator go here.
          (vbx  (gtk-vbox-new #f 2)) 
          
          ;; A scrolling window
          (sw (gtk-scrolled-window-new))
          ;; A text buffer
	  (txt (gtk-text-buffer-new))
	  ;; Iters to operate on the text buffer
	  (startit (gtk-frame-new))
	  (endit   (gtk-frame-new))
	  ;; A text view to see the contents of txt.
          (tv (gtk-text-view-new-with-buffer txt))
          
          ;; A table to hold the buttons, the text entry,
          ;; and the scrolling window.
          (tbl  (gtk-table-new 20 20 1))
          
          (fname "")   ]
    
     (pack-homogeneously hbx ext lod sav)
     (pack-pack vbx hbx en sep)
     
     (gtk-container-add sw tv)
     (gtk-table-attach-defaults tbl vbx 0 10 0 4 )
     (gtk-table-attach-defaults tbl sw 0 19 5 19)
	   
     (gtk-text-view-set-editable tv 1)
     (gtk-text-view-set-wrap-mode tv 2)
	  
     (gtk-container-add  win tbl)
     (gtk-window-set-title win "Demo with GTK-server lib")  
     (gtk-widget-show-all win)
     
     (play-with event until (equal? event ext) thus
        [ sav
          (set! fname (gtk-entry-get-text en))                    
          (set! fname (if (< (string-length fname) 2) "backup.txt" fname))
          (gtk-save-buffer txt fname startit endit)]
        [ lod
          (set! fname (gtk-entry-get-text en))
          (gtk-ins-lines (gtk-load-lines fname) txt endit)]
     )
  )
)
          


;; This example shows how a macro can make a program easier
;; to read. In fact, the macro play-with eliminates a few
;; parentheses, and spare us from a few program lines.
      
